/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
#include "player.h"
#include "Camera.h"
#include "main.h"
#include "switch.h"

cameraparms Camera;
cameraparms CameraTrigger[MAX_SWITCHES];
s16 camera_followx,camera_followy;
u16 Camera_Time;

extern s16 game_x;
extern s16 game_y;

void HandleCamera(void);


void initcamera(void)
{
//	Object[num_strats].handle = HandleCamera;
//	Object[num_strats].remover = 0;
    Camera.xpos = parm_xpos;
    Camera.ypos = parm_ypos;
    Camera.state = 1;
    Freeze_Player = 1;
    Camera.fade = -15;
    fadeto = 0;
    Camera.restorex = game_x;
    Camera.restorey = game_y;
    
    // fade here...
}

void HandleCamera(void)
{

	//AGBPrintf("camera = %d\n",Object[current_strat].parameter);
	//AGBPrintFlush();
	if(Camera_Time > 0 && Camera.state == 1) // object parameter used as timer for Camera
	{
		Camera.fade = max(1,Camera.fade);
	//	if(Camera.fade > 0)
		{
			if(Camera.fade < 16)
			{
				Camera.fade++;
			}
			if(camera_followx)
			{
				Camera.xpos = max(0,min(PlayerMapWidth * 8 - 240,camera_followx - 120));
				Camera.ypos = max(0,min(PlayerMapHeight * 8 - 160,camera_followy - 80));
				camera_followx = 0;
			}
			else
			{
				Camera_Time--;
			
			}
			game_x = Camera.xpos;
			game_y = Camera.ypos;
		}
/*
		else
		{
			if(fadetolevel == 15)
			{
				fadeto = 0;
				Camera.fade = 1;
				game_x = Camera.xpos;
				game_y = Camera.ypos;
			}
		}
*/
	}
	else
	{
		if(Camera.fade > -16)
		{
			if(Camera.fade > 0)
			{
				Camera.fade--;
				fadeto = 15;
			}
			else
			{
				game_x = Camera.restorex;
				game_y = Camera.restorey;
				Camera.fade--;
				fadeto = 0;
			}
		}
		else
		{
			Camera.state = 0;
			Freeze_Player = 0;
			//AGBPrintf("camera done!\n",Object[current_strat].parameter);
			//AGBPrintFlush();
	//		remove();
		}
	}
}	

u8 NextCamTrigger(void)
{
	u8 a;
	for(a = 0; a < MAX_SWITCHES; a++)
	{
		if(CameraTrigger[a].xpos == 0)
			return a;
	}
	return 0;
}

void RemoveCameraTrigger(void)
{

	u8 me;
	me = Object[current_strat].parameter;
	CameraTrigger[me].xpos = 0;
}

void initcameratrigger(void)
{
	u8 me;
	
	me = NextCamTrigger();
	Object[num_strats].handle = HandleCameraTrigger;
	Object[num_strats].remover = RemoveCameraTrigger;
	CameraTrigger[me].xpos = parm_xpos - 120;
	CameraTrigger[me].ypos = parm_ypos - 80;
	CameraTrigger[me].state = Object[num_strats].parameter;
	Object[num_strats].parameter = me;	
}

void HandleCameraTrigger(void)
{
	u8 me;
	me = Object[current_strat].parameter;
	
	if(tswitch[CameraTrigger[me].state].state)
	{
		lastcamera = CameraTrigger[me].state;
		parm_xpos = CameraTrigger[me].xpos;
		parm_ypos = CameraTrigger[me].ypos;
		Camera_Time = 60;
		initcamera();
		remove();
	}

}
