/*********************************************/
/*  player.h  test player strat routine      */
/*********************************************/

#define BOHROK_WALK		0
#define BOHROK_RECOVER	1
#define BOHROK_ROLL		2
#define BOHROK_HIT		3
#define	BOHROK_REBOUND	4
#define BOHROK_WAIT		5

void initenemybohrok();

void HandleBohrok();

void initloaderbohroks(void);  // spins across loading screen
void HandleLoaderBohrok(s16 clock);


typedef struct {
	s16 xpos;
	s16 ypos;
	s16 patrollx;
	s16 patrolrx;
	s16 floor; 
	s16 floorl;
	s16 floorr;
	s8 timer; // also gets used as dy
	s8 dx;
	u8 frame;
	u8 state;
	s8 health;
	u8 clock;
	s8 dclock;
	u8 preroll;
	u8 pal; // colour (based on hitpoints + speedup)
	u8 rolls;
	u8 onswitch;
	u8 killswitch;
} bohrokparms;

