// menu.c
#include <Agb.h>
#include "asldefines.h"
#include "particles.h"
//#include "data.h"
#include "screen.h"
#include "menubutton.h"
#include "button.h"
#include "newmenu.h"
#include "main.h"
#include "MenuButtons.h"
#include "islandmap.h"
#include "mainmenu.h"
#include "menuoverlay.h"
#include "font16.h"
#include "mask.h"
#include "player.h"
#include "strings.h"
#include "spot.h"
#include "daytonight_rain.h"
#include "rainbow_rain.h"
#include "SampleManager.h"
//#include "credits.h"
#include "text.h"
#include "flags.h"
#include "levelicons.h"
#include "menu.h"
#include "FEBack.h"


#include "mod_title.h"
#define GAME_MIXER_RATE	MIXER_RATE_HZ_10512




extern s16 game_x;
extern s16 game_y;
extern s16 last_map_x;
extern u8 Game_Level;
extern u8 Game_Character;
extern u16 SaveGame[64];
extern u8 GameSlot[2];


Funcp MenuControl;
Funcp MenuControlOld;
Funcp MenuReturn;
u8 MenuYesNo;
u8 MenuQuestion;
u8 MenuSaveSelect;
u8 MenuSaveSelect2;
u8 Cheatmode;

u8 ButtonHold;
u8 exitmenu;
u8 LanguageDone;
u16 MenuTimeout;

u8 MenuFlipText;
u8 cancel;

s16 credx[6];
s16 credy[6];
u8 credl[6];
u8 credlinenext;

u8 MenuNewGame;

const u8 menux[6] = {64,48,64,48,64,48};
const u8 menuy[6] = {24,64,104,64,24,64};
const u8 menuchar[6] = {5,3,6,7,4,8};
const u8 CharLine[6] = {0,2,4,1,3,5};
const u8 CharMaskCol[6] = {2,4,0,1,3,5};

const u8 LevelToArea[20] = {1,1,1,4,4,3,3,3,3,2,2,5,5,5,6,6,6,6,6,6};


const u16 MainMenuPalette[16] ={ // palette data
0,0x7f39,0x7af7,0x76b5,0x6e94,0x6a52,0x6610,0x5def,0x59ad,0x516b,0x4d29,0x4908,0x40c6,0x3c84,0x3863,0x2ca5
};
u8 MenuCycle;

u8 Game_Level_Start[6];  // 0 3 11 9 5 15


u16 menuscroll_x,menuscroll_y;
s8 menuscroll_dx,menuscroll_dy;

const u8 Cheat_Level_Start[6] = {0,5,11,3,9,15};

const u8 faderstring[8][8] = {"OFF","t","tu","tuv","tuvw","tuvwx","tuvwxy","tuvwxyz"};

void MenuMainControl(void);
void MenuCharacterControl(void);
//void MenuCreditsControl(void);
void MenuOptionsControl(void);
void MenuPasswordControl(void);
void SleepMode(void);
void MenuLanguageControl(void);
void MenuOverwriteCheck(void);
void MenuClearGamesCheck(void);
void MenuYesNoControl(void);

void MenuWipeRing()
{
	u16 bgr;
	u16 * ptr;
	u8 a;
	ptr = BG_PLTT + 14;
	bgr = *ptr;
	for(a = 33;a< 50; a++)
	{
		ptr = BG_PLTT + a * 2;
		*ptr = bgr;

	}	

}

void MenuLoop()
{
	s8 fade;
		u16 bgr;
		u16 * ptr;
	u8 a;
	u8 mselo;
		
	MenuTimeout = 0;
		lightningtime = 0;

	fade = 0;
	while(fade <= 15)
	{
		WipeToBlack(fade++);
		ArgoVBlank();
		
	}
	fade = 15;
	// Reset everything
	num_strats = 0;		// get rid of all current strats
	Boss_xpos = 0;
	MiniMode = 0;
	MapActive = 0;
	*(vu16 *)REG_DISPCNT = DISP_MODE_0 | DISP_OBJ_ON |  DISP_OBJ_CHAR_1D_MAP; // LCDC ON
	MenuScreen();
	Rainbow = 0;
//	MenuScreenLayer1();
			pad_L =	L_BUTTON;
			pad_R =	R_BUTTON;
			pad_A =	A_BUTTON;
			pad_B =	B_BUTTON;
	
 	*(vu16 *)REG_BG0VOFS = 0;
	*(vu16 *)REG_BG0HOFS = 0;
 	*(vu16 *)REG_BG1VOFS = 0;
	*(vu16 *)REG_BG1HOFS = 0;
	  
    num_strats = 0;		// get rid of all current strats
   	KillButtons();
   	KillBigChars();
    DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
  	DmaWait(3);
    DmaArrayCopy(3, Sprite,          OAM,            32);
	DmaWait(3);
    
    DmaArrayCopy(3, MainMenuChar, BG_VRAM + 0x4000, 32);  //  Set BG character
	DmaWait(3);
    DmaArrayCopy(3,MainMenuMap,BG_VRAM,32);
	DmaWait(3);
	DmaArrayCopy(3,FEBackMap,BG_VRAM + 2048 * 2,32);
	DmaWait(3);
 	DmaArrayCopy(3,FEBackChar,BG_VRAM + 0x8000,16);
 	DmaWait(3);
 	DmaArrayCopy(3,FEBackPalette,BG_PLTT,32);
 	DmaWait(3);
    DmaCopy(3, &MainMenuPalette[0], BG_PLTT, 32,        32);  //  Set BG palette
	DmaWait(3);
 //   DmaArrayCopy(3, MainMenuGlowChar, BG_VRAM + 0x8000, 32);  //  Set BG character
//	DmaWait(3);
 //    DmaArrayCopy(3,MainMenuGlowMap,BG_VRAM + 2048,32);
//	DmaWait(3);

	//MenuWipeRing();

	while(fade >= 0)
	{
		WipeToBlack(fade--);
        ArgoVBlank();                           // Complete V Blank interrupt
	}

	*(vu16 *)REG_BLDCNT =  BLD_A_BLEND_MODE | BLD_BG0_1ST | BLD_BG2_2ND;
 
	*(vu16 *)REG_BLDALPHA = (10) + ((14) << 8);
	KeyRead();

//   	spawn(initmenubutton,120 - 64,16,0);

	exitmenu = 0;
	if(controller & (pad_L | pad_R) && LanguageDone == 0) // cheat, make chars start at their levels
	{
		Cheatmode = 1;
		if(controller & pad_select) // erase saved games
		{
			Cheatmode = 3;
		}
	}
	if(controller & (pad_A | pad_B) && LanguageDone == 1 && Cheatmode > 0)
	{
		if(Cheatmode == 1) 
		{
			Cheatmode = 2;
		}
		else
		{
			if(Cheatmode == 3)
			{
				if(controller & pad_up)
				{
					Cheatmode = 4;
				}
			}
		}
	}	
	
	if(LanguageDone)
		MenuControl = MenuMainControl;
	else
		MenuControl = MenuLanguageControl;
	
	MenuBase = 0;
	menuselect = 0; // 0 = character select, 1 = options, 2 = credits, 3 = password
	ButtonWipeoff = 59;
	LoadSprite((u32)FontBigSprite,BIGTEXT_MSPRITE_OFFSET ,BIGTEXT_MSPRITE_SIZE * 67);
	LoadSprite((u32)LeIconSprite,BIGICON_MSPRITE_OFFSET ,BIGICON_MSPRITE_SIZE * 6);

	
	NextSprite = 16;
	
	LastSprite = 17;
	player.elemental_power = 0; // (again range 0 - 128)
	player.lives = 3; // 3 lives (vary with difficulty level)
	Frisbee_Power = 0;

	if(Cheatmode == 2)
	{
		for(a = 0; a < 6;a++)
		{
			CharAvail[a] = 1;
			Game_Level_Start[a] = Cheat_Level_Start[a];
		}
		
	}
	MenuCycle = 14;

	menuscroll_dx = -2;
	menuscroll_dy = -1;
	while(!exitmenu && MenuTimeout < 60  * 20)
	{
		u16 line;
		
		MenuTimeout = 0;
	//	*(vu16 *)BG_PLTT = rainbow_rain[daytime];
	//	*(vu16 *)(BG_PLTT + 34) = rainbow_rain[(daytime + 64) & 255];
	//    if(MenuControl != MenuLanguageControl)
	//	{
	 //   	*(vu16 *)REG_BG2VOFS = -(menuscroll_y >> 2);
  	 //		*(vu16 *)REG_BG2HOFS = -(menuscroll_x >> 2);
  	 //	}
  	 	menuscroll_x = (menuscroll_x + menuscroll_dx) & 1023;
  	 	menuscroll_y = (menuscroll_y + menuscroll_dy) & 1023;
  	 	
		daytime = (daytime + 1) & 255;
  		KeyRead();                                 	 // Key control
        ArgoVBlank();                           // Complete V Blank interrupt
   		handle_strats();
   	//	DoParticles();
		GameClock++;			//< General purpose internal timer, counts 0 - 0x7ff can be used by anything in game
		GameClock &= 0x7ff;
	
	
		if(MenuCycle > 0)
		{
			if((GameClock & 3) == 0)
			{
				MenuCycle--;
			//	CycleMapColour(0,1,14);
			}
		}	
		if(LastSprite > NextSprite)
		{
			u32 dest;
			u32 length;
			dest = &Sprite[NextSprite];
			length= (LastSprite - NextSprite) * 8;
			DmaClear(3,161,dest,length,32)
		}
		LastSprite = NextSprite;
		NextSprite = 16;
//		if(MenuControl != MenuControlOld)
			//	MenuWipeRing();
		MenuControlOld = MenuControl;
		if(ButtonReady != 0 && ButtonHold > 0)
			ButtonHold--;
		
		if(ButtonReady == 0 || ButtonWipeoff > 0 || ButtonHold > 0)
		{
			controller = 0;
			controller_push = 0;
			if(ButtonReady == 0)
				ButtonHold = 15;
		}
		mselo = menuselect;
		MenuControl();

		if(Cheatmode == 4 && controller == 0 && MenuControl != MenuYesNoControl && MenuControl != MenuClearGamesCheck)
		{
			if(GameSlot[0] != 0 || GameSlot[1] != 0)
			{
				MenuReturn = MenuClearGamesCheck;
				MenuQuestion = 57; // overwrite Y/N
				menuselect = 2;
				MenuControl = MenuYesNoControl;
				ButtonWipeoff = 1;
			}
			

		}

		if(menuselect != mselo)
		{
			Sample_Play(SMPL_DRIP01); // change
		}
		if(MenuControlOld != MenuControl)
		{	
			Sample_Play(SMPL_SELECT);
		}
		if(cancel)
		{	
			Sample_Play(SMPL_MATORAN_SUCKED);
			cancel = 0;
		}	
		if(ButtonWipeoff > 0)
		{
			if(ButtonWipeoff < 16)
			{
				ptr = BG_PLTT + (ButtonWipeoff + 32) * 2;
				*ptr = 0x7fff;
				
				
			}
		}
	//	daytime = 0;
		if(controller)
			MenuTimeout = 0;	
		MenuTimeout++;
	
	
	}
	BigTextRemove(0);
	
	if(MenuTimeout >= 60 * 20)
	{
		BlendAlpha(5,8);
 		removeall();
	 	DisplayLego();
 		//DisplayArgonaut();
 	//	DisplayBionicleLogo();
 		DisplayBionicle();
 		DisplaySplash();
		Game_Level = 1;
		Game_Character = 0;
		MapActive = 0;
		GameStateLoop = MenuLoop;
		HBlankRoutine(HBlankMenu);
		
		NextSprite = 64;   //< For the dynamic sprite allocation routine, next sprite to use
		
		LastSprite = 65;	//< also for the dynamic sprites. Last sprite (+1) dynamically assigned
	   	fadeto = 0;
	   	fadetolevel = 0;
	   	GoingToSleep = 0;
	}
	else
	{
		fade = 0;
		
		if(	LanguageDone)
		{
			SampleManager_Halt();
			PauseScreenState = *(vu16 *)REG_DISPCNT;
			StoreHVBlank();
			MemcardLoop();
			TextClear();
		}
		LanguageDone = 1;

		MosaicOut();
		fadeval = 1;
		GameStateLoop = MosaicOutLoop;
		if(Game_Controls == 0)
		{
			pad_L =	L_BUTTON;
			pad_R =	R_BUTTON;
			pad_A =	A_BUTTON;
			pad_B =	B_BUTTON;

		}
		else
		{
			pad_L =	R_BUTTON;
			pad_R =	L_BUTTON;
			pad_A =	B_BUTTON;
			pad_B =	A_BUTTON;
			
		
		}
	

	}
	Screen2(0);
	if(Cheatmode == 4)
		Cheatmode = 0;
}

void MenuMainControl(void)
{
	u8 a;
	u8 gamesloaded;
	
	gamesloaded = 0;

	if(VBlankRoutine != VBlankMenu)
	{
		VBlankRoutine = VBlankMenu;
		MapActive = 0;
	}
	if(GameSlot[0] || GameSlot[1])
		gamesloaded = 1;
	
		if(controller_push & pad_left || controller_push & pad_up)
		{
			menuselect = (menuselect + (1 + gamesloaded)) % (2 + gamesloaded);
		}
		if(controller_push & pad_right || controller_push & pad_down)
		{
			menuselect = (menuselect + 1) % (2 + gamesloaded);
		}
		if(controller_push & (pad_start | pad_A)) // select
		{
			
			switch(menuselect)
			{
				case 0:
					MenuControl = MenuPasswordControl;	
					ButtonWipeoff = 1;
					// go to select new game first
					MenuNewGame = 1;
					Sample_Play(SMPL_START);
					break;
				case 2:
					MenuControl = MenuOptionsControl;
					ButtonWipeoff = 1;
					break;
				case 1:
					if(gamesloaded == 0)
					{
						MenuControl = MenuOptionsControl;
						ButtonWipeoff = 1;
					}
					else
					{
						MenuControl = MenuPasswordControl;
						ButtonWipeoff = 1;
						MenuNewGame = 0;
					}
					break;


			}

		}
		if(ButtonWipeoff) // handle previous menu's buttons wiping off screen
		{
			ButtonWipeoff++;
			if(ButtonWipeoff == 60)
			{
			
				if(MenuCycle == 0)
					MenuCycle = 14;
			
				TextAutoCentre = 1;
				ArgoVBlank();	    
			    DmaCopy(3, FEBackPalette + 32, BG_PLTT + 32,   32,     32);  //  Set BG palette
				DmaWait(3);
	    		KillBigChars();
				KillButtons();
				DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
				removeall();
				
				ButtonWipeoff = 0;
				menuselect = 0; // 0 = character select, 1 = options, 2 = credits, 3 = password
				spawn(initmenubutton,64,24,0);
				initmenubutton2();
				if(gamesloaded)
				{
					spawn(initmenubutton,48,64,2);
					initmenubutton2();
					spawn(initmenubutton,48,104,1);
					initmenubutton2();
				}
				else
				{
					spawn(initmenubutton,48,64,1);
					initmenubutton2();
				}
			}
		}

}

void MenuLanguageControl(void)
{
	s16 country;
	
		ButtonReady = 1;
		if(controller_push & pad_left || controller_push & pad_up)
		{
			menuselect = (menuselect + 7) % 8;
		}
		if(controller_push & pad_right || controller_push & pad_down)
		{
			menuselect = (menuselect + 1) % 8;
		}
		if(controller_push & (pad_start | pad_A)) // select
		{
			
			Lingo = menuselect;
			MenuControl = MenuMainControl;	
			menuselect = 0;
			ButtonWipeoff = 1;
	TextClear();
			TextOff();
			removeall();
			exitmenu = 1;
    DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
  	DmaWait(3);
    DmaArrayCopy(3, Sprite,          OAM,            32);
	DmaWait(3);
	Screen3(0);

		}
		
		MenuTimeout = 0;
	
		if(ButtonWipeoff) // handle previous menu's buttons wiping off screen
		{
			ButtonWipeoff++;
			if(ButtonWipeoff == 60)
			{
				if(MenuCycle == 0)
					MenuCycle = 14;
				ArgoVBlank();	    

			    DmaCopy(3, FEBackPalette + 32, BG_PLTT + 32,   32,     32);  //  Set BG palette
				DmaWait(3);
	    		KillBigChars();
				KillButtons();
				DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
				removeall();
				TextOn();
				TextClear();
				ButtonWipeoff = 0;
				menuselect = 0; // 0 = character select, 1 = options, 2 = credits, 3 = password
				TextAutoCentre = 1;
			//	spawn(initflagsprite,152,72,0);
			//	TextAutoCentre = 0;
				for(country = 0; country < 8;country ++)
				{
					TextCentre(-16,country * 16 + 16,&ButtonText[country][country + 43][0]);
				}
			}
		}

}



void MenuCharacterControl(void)
{
	s8 fade;
	u8 a;
	if(controller_push & pad_left || controller_push & pad_up)
	{
		menuselect = (menuselect + 5) % 6;
		while(CharAvail[CharLine[menuselect]] == 0)
			menuselect = (menuselect + 5) % 6;
	}
	if(controller_push & pad_right || controller_push & pad_down)
	{
		menuselect = (menuselect + 1) % 6;
		while(CharAvail[CharLine[menuselect]] == 0)
			menuselect = (menuselect + 1) % 6;
	}
	
	if(controller_push & (pad_start | pad_A)) // select
	{
        ArgoVBlank();                           // Complete V Blank interrupt
	//	MenuControl = MenuMapControl;
		exitmenu = 1;
		game_x = 0;
		game_y = 0;
		PlayerMapWidth = 1024;
		PlayerMapHeight = 40;	
		last_map_x = -1;	
		fade = 0;
		Game_Level = Game_Level_Start[menuselect];
		Game_Character = menuselect;
		Rainbow = &daytonight_rain[0];
		

	}
	if(controller_push & pad_B) // go back
	{
		MenuControl = MenuMainControl;
		ButtonWipeoff = 1;
		menuselect = 0;
		cancel = 1;
	}
	
	if(ButtonWipeoff) // handle previous menu's buttons wiping off screen
	{
		ButtonWipeoff++;
		if(ButtonWipeoff == 60)
		{
			if(MenuCycle == 0)  // 3367
				MenuCycle = 14;

			    DmaCopy(3, FEBackPalette + 32, BG_PLTT + 32,   32,     32);  //  Set BG palette
			DmaWait(3);
   		KillBigChars();
			KillButtons();
    		DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
			removeall();
			ButtonWipeoff = 0;
			menuselect = 0; // 0 = character select
			
			TextAutoCentre = 0;
			spawn(initmenubutton,88,4,5);
			initmenubutton2();
			spawn(initmenubutton,62,25,52 - CharAvail[2] * 49  );
			initmenubutton2();
			spawn(initmenubutton,48,50,52 - CharAvail[4] * 46);
			initmenubutton2();
			spawn(initmenubutton,48,79,52 - CharAvail[1] * 45);
			initmenubutton2();
			spawn(initmenubutton,62,105,52 - CharAvail[3] * 48);
			initmenubutton2();
			spawn(initmenubutton,88,124,52 - CharAvail[5] * 44);
			initmenubutton2();
			spawn(initmask,128,49,0);
			TextAutoCentre = 1;
				ArgoVBlank();	    
		}
	}
}


void MenuYesNoControl(void)
{
	
	if(controller_push & pad_left || controller_push & pad_up || controller_push & pad_right || controller_push & pad_down)
	{
		menuselect = 3 - menuselect;
	}
	
	if(controller_push & (pad_start | pad_A)) // select
	{
		MenuControl = MenuReturn;
		ButtonWipeoff = 1;
		MenuYesNo = 2 - menuselect;
		menuselect = 0;
	}
	if(controller_push & pad_B) // go back
	{
		MenuControl = MenuMainControl;
		ButtonWipeoff = 1;
		MenuYesNo = 0;
		menuselect = 0;
		cancel = 1;
	}
	
	if(ButtonWipeoff) // handle previous menu's buttons wiping off screen
	{
		ButtonWipeoff++;
		if(ButtonWipeoff == 60)
		{
			if(MenuCycle == 0)
				MenuCycle = 14;
						ArgoVBlank();	    

			    DmaCopy(3, FEBackPalette + 64, BG_PLTT + 32,   32,     32);  //  Set BG palette
			DmaWait(3);
    		KillBigChars();
			KillButtons();
    		DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
			removeall();
			ButtonWipeoff = 0;
			menuselect = 2; // 0 = character select
			spawn(initmenubutton,4,25,MenuQuestion);
			initmenubutton2();
			spawn(initmenubutton,48,50,55); // yes
			initmenubutton2();
			spawn(initmenubutton,48,79,56); // no
			initmenubutton2();
		}
	}

}

#if 0
void MenuCreditsControl(void)
{
	u8 a;

	MenuTimeout = 0;
	menuselect = 10; // stop things flashing

	if((controller_push & (pad_B | (pad_start | pad_A))) || (game_y == (PlayerMapHeight * 128 - 160) ) )
	{
		MenuScreen();
		
		MapActive = 0;
		MenuControl = MenuOptionsControl;
		ButtonWipeoff = 1;
	   DmaArrayCopy(3, MainMenuChar, BG_VRAM + 0x4000, 32);  //  Set BG character
		DmaWait(3);
	    DmaArrayCopy(3,MainMenuMap,BG_VRAM,32);
		DmaWait(3);
		DmaArrayCopy(3,FEBackMap,BG_VRAM + 2048 * 2,32);
		DmaWait(3);
	 	DmaArrayCopy(3,FEBackChar,BG_VRAM + 0x8000,16);
	 	DmaWait(3);
	 	DmaArrayCopy(3,FEBackPalette,BG_PLTT,32);
	 	DmaWait(3);
	    DmaCopy(3, &MainMenuPalette[0], BG_PLTT, 32,        32);  //  Set BG palette
		DmaWait(3);
		*(vu16 *)REG_BG0VOFS = 0;
		*(vu16 *)REG_BG0HOFS = 0;
	 	*(vu16 *)REG_BG1VOFS = 0;
		*(vu16 *)REG_BG1HOFS = 0;
		*(vu16 *)BG_PLTT = 0;
	}
	
	game_x = 0;
	if((GameClock & 3) == 0 && game_y < (PlayerMapHeight * 8 - 160))
		game_y++;
	
	
	if(ButtonWipeoff) // handle previous menu's buttons wiping off screen
	{
		ButtonWipeoff++;
		if(ButtonWipeoff == 60)
		{
			if(MenuCycle == 0)
				MenuCycle = 14;
						ArgoVBlank();	    

			    DmaCopy(3, FEBackPalette + 80, BG_PLTT + 32,   32,     32);  //  Set BG palette
			DmaWait(3);
    		KillBigChars();
			KillButtons();
    		DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
			removeall();
			ButtonWipeoff = 0;
			menuselect = 0; // 0 = character select

		
			GameScreen();
		   	
		   	
		   	DmaArrayCopy(3,tiles_credits,BG_VRAM + 0x4000,32); // main map tiles (16k block 1)
			TestDecompress((u8 *)layer_credits_2,(s16 *)WorkMap,&PlayerMapWidth,&PlayerMapHeight);
		  	DmaArrayCopy(3, MainMenuChar, BG_VRAM + 0xc000, 32);  //  Set BG character
			DmaWait(3);
			LoadMapPalette(palettes_credits);

   			DmaArrayCopy(3,MainMenuMap,BG_VRAM + 4096,32);
		//	LoadMapPalette(MainMenuPalette);
			MapActive = 1;
			game_x = 0;
			game_y = 0;
			*(vu16 *)(BG_PLTT + 484) = 0;
			Screen1(0);
			Screen2(0);

		*(vu16 *)REG_BG0VOFS = 0;
		*(vu16 *)REG_BG0HOFS = -8;
	 	*(vu16 *)REG_BG1VOFS = 0;
		*(vu16 *)REG_BG1HOFS = 0;
		*(vu16 *)BG_PLTT = 0;



		}
	}
	
	
}
#endif

void MenuSFXControl(void)
{
	if(controller_push & (pad_B | (pad_start | pad_A)))
	{
		MenuControl = MenuOptionsControl;
		ButtonWipeoff = 1;
	}
	
	if(controller_push & pad_left)
	{
		SFX_Volume = max(0,SFX_Volume - 1);
		SampleManager_SetEffectsVolume(SFX_Volume * 36 + (SFX_Volume / 2));
   			Sample_Play(SMPL_MATORAN_SERVO);
		BigTextRemove(MenuFlipText);
		MenuFlipText = 1 - MenuFlipText;
		if(SFX_Volume == 0)
		{
			BigText(MenuFlipText,64,80,&ButtonText[Lingo][79][0]);
		}
		else
		{
			BigText(MenuFlipText,64,80,&faderstring[SFX_Volume][0]);
		}	
	}
	
	if(controller_push & pad_right)
	{
		SFX_Volume = min(7,SFX_Volume + 1);
		SampleManager_SetEffectsVolume(SFX_Volume * 36 + (SFX_Volume / 2));
   			Sample_Play(SMPL_MATORAN_SERVO);
		BigTextRemove(MenuFlipText);
		MenuFlipText = 1 - MenuFlipText;
		if(SFX_Volume == 0)
		{
			BigText(MenuFlipText,64,80,&ButtonText[Lingo][79][0]);
		}
		else
		{
			BigText(MenuFlipText,64,80,&faderstring[SFX_Volume][0]);
		}	
	}
	
	if(ButtonWipeoff) // handle previous menu's buttons wiping off screen
	{
		ButtonWipeoff++;
		if(ButtonWipeoff == 60)
		{
			if(MenuCycle == 0)
				MenuCycle = 14;
						ArgoVBlank();	    

			    DmaCopy(3, FEBackPalette + 96, BG_PLTT + 32,   32,     32);  //  Set BG palette
		DmaWait(3);
   		KillBigChars();
			KillButtons();
    		DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
			removeall();
			ButtonWipeoff = 0;
			menuselect = 99; // 0 = character select
			MenuFlipText = 0;
		if(SFX_Volume == 0)
		{
			BigText(MenuFlipText,64,80,&ButtonText[Lingo][79][0]);
		}
		else
		{
			BigText(MenuFlipText,64,80,&faderstring[SFX_Volume][0]);
		}	
			BigText(2,48,50,&ButtonText[Lingo][10][0]);

		}
	}	
	
}

void MenuMusicControl(void)
{
	if(controller_push & (pad_B | (pad_start | pad_A)))
	{
		MenuControl = MenuOptionsControl;
		ButtonWipeoff = 1;
	}
	
	if(controller_push & pad_left)
	{
		Music_Volume = max(0,Music_Volume - 1);
		SampleManager_SetMusicVolume(Music_Volume * 33 );
		BigTextRemove(MenuFlipText);
		MenuFlipText = 1 - MenuFlipText;
		if(Music_Volume == 0)
		{
			BigText(MenuFlipText,64,80,&ButtonText[Lingo][79][0]);
		}
		else
		{
			BigText(MenuFlipText,64,80,&faderstring[Music_Volume][0]);
		}		
	}
	
	if(controller_push & pad_right)
	{
		Music_Volume = min(7,Music_Volume + 1);
		SampleManager_SetMusicVolume(Music_Volume * 33 );

		BigTextRemove(MenuFlipText);
		MenuFlipText = 1 - MenuFlipText;
		if(Music_Volume == 0)
		{
			BigText(MenuFlipText,64,80,&ButtonText[Lingo][79][0]);
		}
		else
		{
			BigText(MenuFlipText,64,80,&faderstring[Music_Volume][0]);
		}		
	}
	
	if(ButtonWipeoff) // handle previous menu's buttons wiping off screen
	{
		ButtonWipeoff++;
		if(ButtonWipeoff == 60)
		{
			if(MenuCycle == 0)
				MenuCycle = 14;
						ArgoVBlank();	    

			    DmaCopy(3, FEBackPalette + 96, BG_PLTT + 32,   32,     32);  //  Set BG palette
			DmaWait(3);
   		KillBigChars();
			KillButtons();
    		DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
			removeall();
			ButtonWipeoff = 0;
			menuselect = 99; // 0 = character select
			MenuFlipText = 0;
		if(Music_Volume == 0)
		{
			BigText(MenuFlipText,64,80,&ButtonText[Lingo][79][0]);
		}
		else
		{
			BigText(MenuFlipText,64,80,&faderstring[Music_Volume][0]);
		}		
			BigText(2,48,50,&ButtonText[Lingo][9][0]);

		}
	}
	
	
}

#if 0
void MenuControlsControl(void)
{
	if(controller_push & (pad_B | (pad_start | pad_A)))
	{
		MenuControl = MenuOptionsControl;
		ButtonWipeoff = 1;
	
	}
	
	if(controller_push & pad_left || controller_push & pad_up)
	{
		menuselect = 1 - menuselect;
	}
	if(controller_push & pad_right || controller_push & pad_down)
	{
		menuselect = 1 - menuselect;
	}

	Game_Controls = menuselect;

	if(ButtonWipeoff) // handle previous menu's buttons wiping off screen
	{
		ButtonWipeoff++;
		if(ButtonWipeoff == 60)
		{
		
			if(MenuCycle == 0)
				MenuCycle = 14;
						ArgoVBlank();	    

			    DmaCopy(3, FEBackPalette + 96, BG_PLTT + 32,   32,     32);  //  Set BG palette
			DmaWait(3);
    		KillBigChars();
			KillButtons();
    		DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
			removeall();
			ButtonWipeoff = 0;
			menuselect = 0; // 0 = character select
			spawn(initmenubutton,48,64,41);
			initmenubutton2();
			spawn(initmenubutton,56,92,42);
			initmenubutton2();
		}
	}
	
	
}
#endif

void MenuDifficultyControl(void)
{

	if(controller_push & pad_B)
	{
		MenuControl = MenuOptionsControl;
		ButtonWipeoff = 1;
		cancel = 1;
	}
	if(controller_push & pad_left || controller_push & pad_up)
	{
		menuselect = (menuselect + 2) % 3;
	}
	if(controller_push & pad_right || controller_push & pad_down)
	{
		menuselect = (menuselect + 1) % 3;
	}


	if(controller_push & (pad_start | pad_A)) // select
	{
		MenuControl = MenuOptionsControl;
		ButtonWipeoff = 1;
		Game_Difficulty = menuselect;
		menuselect = 0;
	}
	
	if(ButtonWipeoff) // handle previous menu's buttons wiping off screen
	{
		ButtonWipeoff++;
		if(ButtonWipeoff == 60)
		{
			if(MenuCycle == 0)
				MenuCycle = 14;
						ArgoVBlank();	    

			    DmaCopy(3, FEBackPalette + 96, BG_PLTT + 32,   32,     32);  //  Set BG palette
			DmaWait(3);
   		KillBigChars();
			KillButtons();
    		DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
			removeall();
			ButtonWipeoff = 0;
			menuselect = Game_Difficulty; // 0 = character select
				spawn(initmenubutton,64,24,14);
				initmenubutton2();
				spawn(initmenubutton,48,64,15);
				initmenubutton2();
				spawn(initmenubutton,64,104,16);
			initmenubutton2();
		}
	}

}

void MenuOptionsControl(void)
{
	s8 fade;
	u8 a;
	if(controller_push & pad_left || controller_push & pad_up)
	{
		menuselect = (menuselect + 2) % 3;
	}
	if(controller_push & pad_right || controller_push & pad_down)
	{
		menuselect = (menuselect + 1) % 3;
	}
	if(controller_push & pad_B) // go back
	{
		MenuControl = MenuMainControl;
		ButtonWipeoff = 1;
		menuselect = 0;
		cancel = 1;
	}
	
	if(controller_push & (pad_start | pad_A)) // select
	{
		switch(menuselect)
		{
			case 0: // Difficulty
				MenuControl = MenuDifficultyControl;
				menuselect = Game_Difficulty;
				break;
				
			case 1: // sound fx
				MenuControl = MenuSFXControl;
		menuselect = 0;
				break;
				
			case 2: // music
				MenuControl = MenuMusicControl;
		menuselect = 0;
				
				break;
			
#if 0	
		case 3: // credits
				for(a= 0; a < 3; a++)
				{
					credx[a] = 0;
					credy[a] = 60 * a;
					credl[a] = 0;
				}
				credlinenext = 0;
				MenuControl = MenuCreditsControl;
		menuselect = 0;
				break;
			
			case 4: // controls
				MenuControl = MenuControlsControl;
		menuselect = 0;
				break;
#endif				
				
		}
		ButtonWipeoff = 1;
	}
	
	if(ButtonWipeoff) // handle previous menu's buttons wiping off screen
	{
		ButtonWipeoff++;
		if(ButtonWipeoff == 60)
		{
			if(MenuCycle == 0)
				MenuCycle = 14;
						ArgoVBlank();	    

			    DmaCopy(3, FEBackPalette + 80, BG_PLTT + 32,   32,     32);  //  Set BG palette
			DmaWait(3);
    		KillBigChars();
			KillButtons();
    		DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
			removeall();
			ButtonWipeoff = 0;
			menuselect = 0; // 0 = character select
			spawn(initmenubutton,72,24,11);
			initmenubutton2();
			spawn(initmenubutton,56,72,10);
			initmenubutton2();
			spawn(initmenubutton,48,116,9);
			initmenubutton2();
#if 0
			spawn(initmenubutton,56,96,13);
			initmenubutton2();

			spawn(initmenubutton,72,116,12);
			initmenubutton2();
#endif
		//	spawn(initmenubutton,88,128,14);
		//	initmenubutton2();
		//	spawn(initmask,128,49,0);
		}
	}
	
}

void MenuOverwriteCheck(void)
{
	if(MenuYesNo == 0) // no
	{
		MenuControl = MenuMainControl;
		ButtonWipeoff = 1;
		menuselect = 0;
	
	}
	else
	{
		MenuControl = MenuCharacterControl;
		ButtonWipeoff = 1;
	}
}

void MenuClearGamesCheck(void)
{
	u8 a;
	if(MenuYesNo != 0) // no
	{
		GameSlot[0] = 0;
		GameSlot[1] = 0;
		for(a = 1; a < 6;a++)
			CharAvail[a] = 0;
		SaveCharAvail();	

	}
	MenuControl = MenuMainControl;
	ButtonWipeoff = 1;
	menuselect = 0;
	Cheatmode = 0;
	SampleManager_Init(GAME_MIXER_RATE);
	Mod_Init(gmod_titlePatternList,gmod_titleSamples);
	VBlankRoutine = VBlankMenu;
	MapActive = 0;
}

void MenuPasswordControl(void) // now load game
{
	u32 password;
	s8 fade;
	u16 check;
	if(controller_push & (pad_start | pad_A)) // select
	{
       u16 result;
       	// check to see if password is valid
    //   	AGBPrintf("Password = %d\n",password);
    //   	AGBPrintFlush();
    		
    		Game_Slot = menuselect;
    		if(GameSlot[menuselect] == 0 || MenuNewGame == 1) // new game, not load
 			{
				MenuControl = MenuCharacterControl;	
				ButtonWipeoff = 1;
				if(GameSlot[Game_Slot] != 0 )
				{
					MenuReturn = MenuOverwriteCheck;
					MenuQuestion = 57; // overwrite Y/N
					menuselect = 2;
					MenuControl = MenuYesNoControl;
				}
 			}
 			else
 			{
	 			memcardinit();
				result = memcardread(16,Game_Slot);
				memcarddone();
				
				check = 0;
				for(fade = 0; fade < 6; fade++)
					check += SaveGame[fade];
				
				if(check != SaveGame[6])
					result = 0xf000; // failed checksum
				else
					LoadGameParameters();
				
				if(result)
				{
					MemCardError(result);
		         	
		         }
		         ArgoVBlank();                           // Complete V Blank interrupt
			//	MenuControl = MenuMapControl;
				exitmenu = 1;
				game_x = 0;
				game_y = 0;
				last_map_x = -1;	
				fade = 0;

				Rainbow = &daytonight_rain[0];
			}
		
	}
	
	if(controller_push & pad_B) // go back
	{
		MenuControl = MenuMainControl;
		ButtonWipeoff = 1;
		menuselect = 0;
		cancel = 1;
	}

	
	if(controller_push & pad_left  )
	{
		menuselect = (menuselect + 1) % 2;
	}
	if(controller_push & pad_right)
	{
		menuselect = (menuselect + 1) % 2;
	}

	if(controller_push & pad_up)
	{
		menuselect = (menuselect + 1) % 2;
	}
	if(controller_push & pad_down)
	{
		menuselect = (menuselect + 1) % 2;
	}
	
	
	if(ButtonWipeoff) // handle previous menu's buttons wiping off screen
	{
		s16 a;
		ButtonWipeoff++;
		if(ButtonWipeoff == 60)
		{
			if(MenuCycle == 0)
				MenuCycle = 14;
						ArgoVBlank();	    

			    DmaCopy(3, FEBackPalette + 64, BG_PLTT + 32,   32,     32);  //  Set BG palette
			DmaWait(3);
    		KillBigChars();
			KillButtons();
    		DmaArrayClear(3,161, Sprite,         32);  // Move undisplayed OBJ to outside of the screen
			removeall();
			ButtonWipeoff = 0;
			menuselect = 0; // 0 = character select

			for(a = 0; a < 2 ; a++) // draw game info
			{
				if(GameSlot[a] == 0)
				{
					MenuSaveSelect = a + 1;
					MenuSaveSelect2 = 0; // new game so no level icon
					spawn(initmenubutton,menux[a + 1],menuy[a + 1],0);
					initmenubutton2();

				}
				else
				{
					MenuSaveSelect = a + 1;
					MenuSaveSelect2 = LevelToArea[(GameSlot[a] - 1) / 8];
					spawn(initmenubutton,menux[a + 1],menuy[a + 1],menuchar[((GameSlot[a] - 1) & 7)]);
					initmenubutton2();
				}
				
			}
			MenuSaveSelect = 0;
			MenuSaveSelect2 = 0;
			spawn(initmenubutton,menux[0],menuy[0],72);
			initmenubutton2();
		}
	}

}


void DrawPauseMenu(void)
{
	TextOn();
	TextClear();
		menuselect = max(0,min(1,menuselect));
		TextCentre(0,56,&ButtonText[Lingo][74][0]); // Paused
	 	TextCentre(0,80,&ButtonText[Lingo][75][0]); // CONTINUE
	 //	Text(64,96,PAUSE3); // RESTART LEVEL
	 //	TextCentre(0,96,PAUSE4); // SLEEP
	 	TextCentre(0,96,&ButtonText[Lingo][81][0]); // EXIT GAME
 	TextColour(31,31,31);
	*(vu16 *)REG_BG3VOFS = 0;
	*(vu16 *)REG_BG3HOFS = 0;
	flash_x = 0;

}

void DrawExitMenu(void)
{
	TextOn();
	TextClear();
	menuselect = 1;
 	TextCentre(0,56,&ButtonText[Lingo][76][0]); // EXIT GAME
	TextCentre(0,80,&ButtonText[Lingo][55][0]); // Yes
 	TextCentre(0,96,&ButtonText[Lingo][56][0]); // No
 	TextColour(31,31,31);
	*(vu16 *)REG_BG3VOFS = 0;
	*(vu16 *)REG_BG3HOFS = 0;
	flash_x = 0;
}


void DrawCongratulations(void)
{
	TextOn();
	TextClear();
	TextCentre(0,56,&ButtonText[Lingo][40][0]);
	TextCentre(0,72,&ButtonText[Lingo][67][0]);
	TextColour(31,31,31);
	*(vu16 *)REG_BG3VOFS = 0;
	*(vu16 *)REG_BG3HOFS = 0;

}


void DrawGameOver(void)
{
	TextOn();
	TextClear();
	TextCentre(0,56,&ButtonText[Lingo][77][0]); // Game OVer
 	TextColour(31,31,31);
	TextColour2(0,0,0);
	*(vu16 *)REG_BG3VOFS = 0;
	*(vu16 *)REG_BG3HOFS = 0;
	flash_x = 0;
	Screen3(1);

}

void DrawLevelText(void)
{
	TextOn();
	TextClear();

	Text(80,56,&ButtonText[Lingo][30 + LevelTextNum][0]);	

 	TextColour(31,31,31);
	*(vu16 *)REG_BG3VOFS = 0;
	*(vu16 *)REG_BG3HOFS = 0;
	flash_x = 0;
	fadeto = 4;
	GameStateLoop = LevelTextLoop;
	LevelTextNum = 0;

}

void LevelText(u8 textnum)
{
	LevelTextNum = textnum ;
	player.health = 5; // give player full health at start of new areas
}

void SleepMode(void)
{
	// first, switch off screen...


	// set up key L & R interupt to return us
  	*(vu16 *)REG_DISPCNT = 0; // display off
  
    ArgoVBlank();                           // Complete V Blank interrupt
   
   
	*(vu16 *)REG_IF = KEY_INTR_FLAG | CASSETTE_INTR_FLAG; // reset key & cart interupt
   *(vu16 *)REG_IE    = KEY_INTR_FLAG |CASSETTE_INTR_FLAG;
	*(vu16 *)REG_KEYCNT = 0xC300; // L AND R
	
    *(vu16 *)REG_IME   = 1;                           // Set IME
	
	while(*(vu16 *)REG_IF & CASSETTE_INTR_FLAG)
	{
		*(vu16 *)REG_IF = CASSETTE_INTR_FLAG;
	}
   *(vu16 *)REG_IME = 0;
	
	
	Stop();	// stop the CPU until L/R pressed
 
   	*(vu16 *)REG_KEYCNT = 0; // clear key interupt
   	
    *(vu16 *)REG_IE    = V_BLANK_INTR_FLAG | H_BLANK_INTR_FLAG ;          // Permit V blank interrupt
                     //  | CASSETTE_INTR_FLAG;          // Permit cassette interrupt
	
    *(vu16 *)REG_IME   = 1;                           // Set IME
	
	GoingToSleep = 0;
	GameScreen();
	DrawPauseMenu();
	menuselect = 0; // return to game
}




