//CALLED WITH THE musicinit(int n) routine

#define MUSIC_OFF 0
#define MUSIC_LEVEL1 1
#define MUSIC_LEVEL2 2
#define MUSIC_LEVEL3 3
#define MUSIC_LEVEL4 4
#define MUSIC_LEVEL5 5
#define MUSIC_LEVEL6 6
#define MUSIC_TITLE 7	//note : only menu sfx may be played with this. Other fx will cause clipping.
#define MUSIC_HISCORE 8  //enter name on hiscore screen
#define MUSIC_MEDAL_B 9  
#define MUSIC_MEDAL_S 10  
#define MUSIC_MEDAL_G 11 
#define MUSIC_INIT 12



//CALLED WITH THE SFX(int n) routine

#define SOUND_BLANK 0
#define SOUND_ENGINE 1		
#define SOUND_ENGINEOFF 2
#define SOUND_THREE 3
#define SOUND_TWO 4
#define SOUND_ONE 5
#define SOUND_GO 6
#define SOUND_WAVE 7 //wave animation when you turn the boat sharply
#define SOUND_HITBUOY 8
#define SOUND_HITSOLIDOBJECT 9
#define SOUND_HITMETALOBJECT 10
#define SOUND_LAND 11	//land from jump
#define SOUND_GOODSTUNT 12  //extra good stunt
#define SOUND_MENU_BACK 13
#define SOUND_MENU_BOATSELECT 14 // Move d-pad to select character or boat
#define SOUND_MENU_SELECT 15
#define SOUND_JUMP 16	//whoosh when going over jump
#define SOUND_BOOST 17	//play once when boost is activated
#define SOUND_SNOWMAN 18  //snowman being knocked down
#define SOUND_MISSBUOY 19	//warning when buoy missed

//The Grind sounds auto loop and play over the engine channel.
//Therefore they should be started as follows ...
//1. Set pitch to 0 
//2. Start Grind sfx  (perhaps modify the pitch a little if the speed changes during grind)
//3. At end of grind : start engine and set correct pitch

#define SOUND_GRIND_ICE 20	
#define SOUND_GRIND_WOOD 21
#define SOUND_GRIND_METAL 22

//Skids are just spot fx like the other sounds. They have low priority so just call them and forget..
#define SOUND_SKID_SAND 23
#define SOUND_SKID_ICE 24
#define SOUND_SKID_MUD 25

//The bonus sounds use the gameboy color compatible chip in the GBA and therefore
//can play simultaneously with the other sounds. 

#define SOUND_BONUS1 26
#define SOUND_BONUS2 27
#define SOUND_BONUS3 28
#define SOUND_UNLOCKNEW 29	//unlock new boat or track
