/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
//#include "data.h"
#include "player.h"
#include "popuphelper.h"
#include "main.h"
#include "buttonsprites.h"
#include "EndDoor.h"

popupparms popup[2];

extern s16 game_x;
extern s16 game_y;
extern s16 Force_Scroll_xpos;

u8 NextPopup(void)
{
	u8 a;
	for(a = 0; a < 16; a++)
		if(popup[a].xpos == 0)
			return a;
	return 0;
}

void RemovePopup(void)
{

	u8 me;
	me = Object[current_strat].parameter;
	popup[me].xpos = 0;
}

void initpopup(void)
{
	u32 i;
	u8 me;
	
	me = NextPopup();
	//AGBPrintf("me = %d\n",me);
	//AGBPrintFlush();
	Object[num_strats].handle = HandlePopup;
	Object[num_strats].remover = RemovePopup;
	
    popup[me].xpos = parm_xpos;
    popup[me].ypos = parm_ypos;
 //	popup[me].frame = GrabASprite();
 	popup[me].button = 0; //Object[num_strats].parameter;
 	if(Object[num_strats].parameter == 2)
 		popup[me].button = 1;
 //	i = popup[me].frame;
		
	Object[num_strats].parameter = me;
}

void HandlePopup(void)
{
	u8 me,a;
	s16 sprx,spry;
	u32 sprite_ptr;
	
	me = Object[current_strat].parameter;
//	mysprite = popup[me].frame;
	
	sprx = popup[me].xpos - game_x + bobtable[GameClock & 31] * 2;
	spry = popup[me].ypos - game_y;
	
	if(sprx > -32 && sprx < 240 && spry > -32 && spry < 160)
	{
		if(Force_Scroll_xpos)
			Force_Scroll_xpos = 0;
		mysprite = NextSprite++; // Bohrok[me].frame;
    	Sprite[mysprite] = *(OamData *)OamData_Sample;
    	Sprite[mysprite].CharNo = EnemySprite[nxtenemy] ;
   		Sprite[mysprite].Pltt = 3;
        Sprite[mysprite].Priority = 0;
        Sprite[mysprite].AffineMode = 0;
        Sprite[mysprite].HFlip = 0;
        Sprite[mysprite].VFlip = 0;
         
		if(popup[me].button == 0)
		{
	   		Sprite[mysprite].Size = HButtonSizeShape[0];
	   		Sprite[mysprite].Shape = HButtonSizeShape[1];
			sprite_ptr = (u32)HButtonSprite; // change to relevant button sprite
			LoadEnemyPalette(HButtonPalette,nxtenemypal);
	    	Sprite[mysprite].CharNo = EnemySprite[nxtenemy] ;
   			Sprite[mysprite].Size = HButtonSizeShape[0];
			LoadEnemySprite(sprite_ptr, 256);
		}
		else
		{
	   		Sprite[mysprite].Size = EndDoorSizeShape[0];
	   		Sprite[mysprite].Shape = EndDoorSizeShape[1];
   			a = (GameClock >> 3) & 3;
			sprite_ptr = (u32)EndDoorSprite + a * 512; // change to relevant button sprite
			LoadEnemyPalette(EndDoorPalette,nxtenemypal);
	    	Sprite[mysprite].CharNo = EndDoorSprite[nxtenemy] ;
   			Sprite[mysprite].Size = EndDoorSizeShape[0];
			LoadEnemySprite(sprite_ptr, 512);
		}
		Sprite[mysprite].Pltt = 2 + PalCache;
		Sprite[mysprite].CharNo = EnemySprite[SpriteCache];
		Sprite[mysprite].HPos = sprx;
		Sprite[mysprite].VPos = spry;
		Sprite[mysprite].Pltt = 2 + PalCache;
			
	}
	
}

