#ifndef __POOL_H__
#define __POOL_H__

typedef struct s_Pool
{
public:
	void Init(void *memstart,int size);

	void *Allocate(int length);
	void Free(void *memstart);

private:
	void *mHeapStart;
	int mHeapSize;
	int mNext;
} Pool;

extern Pool gPool;

#endif
