/*********************************************/
/*  player.h  test player strat routine      */
/*********************************************/

#define ENEMY_ROCK		4
#define ENEMY_DROPPER	5

void initrock();
void initdropper();
void initrubble();
void initrubblefall();
void initrockfall(void);
void initswingingrock(void);

void HandleRock();
void HandleDropper(void);
void HandleRubble(void);
void HandleRockfall(void);
void HandleSwingingRock(void);
void HandleRubble2(void);

typedef struct {
	s16 xpos;
	s16 ypos;
	s16 patrollx;
	s16 patrolrx;
	s16 startx;
	s16 starty;
	
	s8 dx;
	s8 dy;
	u8 frame;
	u8 mode;
	u8 mytrigger;
	
} rockparms;

typedef struct {
	s16 xpos;
	s16 ypos;
	s16 trigx;
	s16 trigy;
	u8 mytrigger;
	s8 dy;
	u8 frame;
	u8 delay;
} dropperparms;

typedef struct {
	s16 xpos;
	s16 ypos;
	s8  dx;
	s8 dy;
	u8 frame;
} rubbleparms;

u8 rockfalltime;
