/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
//#include "data.h"
#include "asldefines.h"
#include "player.h"
#include "dyson.h"
#include "main.h"
#include "dysonsprites.h"
#include "platformsprite.h"


u16 currsprite;
u8 frameclock;
dysonparms dyson;
u8 playergrabbed;
u8 dysonactive;

extern s16 game_x;
extern s16 game_y;

void HandleDyson(void);

void initdyson(void)
{
	u32 i;
	u8 me;
//	AGBPrintf("DYSON_SPRITE = %d\n",DYSON_SPRITE);
//	AGBPrintf("Offset = %d\n",DYSON_SPRITE_OFFSET);
//	AGBPrintFlush();
	Object[num_strats].handle = HandleDyson;
	Object[num_strats].remover = 0;
	i = 96;
      	Sprite[i].CharNo = DYSON_SPRITE;
    //   	Sprite[i].Shape = OAM_SQUARE;
    	Sprite[i].Shape = DysonSizeShape[1];
   		Sprite[i].Size = DysonSizeShape[0]; //OAM_SIZE_64x64;
   		Sprite[i].Pltt = 15;
         Sprite[i].Priority = 1;
        dyson.xpos = 0;
        dyson.ypos = -24;
        dyson.height = 24;
 	Object[num_strats].parameter = me;
 	playergrabbed = 0;
 	dysonactive = 1;
 	LoadPalette(DysonPalette,15); // override particle palette
}

void HandleDyson(void)
{
	u8 frame;
	s16 sprx,spry;
	u8 a,h,o;

	sprx = player.xpos - game_x - 16;
	spry = dyson.ypos;

	h = dyson.height >> 3;
	o = dyson.height & 7;
	for(a = 0; a < h; a++)
	{
		frame = 0;	// the tube
		if(a == (h - 1))  // the opening
			frame = 2;
		if(a == (h - 2)) // bit before the opening
			frame = 1;
    	Sprite[96 + a] = *(OamData *)OamData_Sample;
		Sprite[96 + a].CharNo = DYSON_SPRITE + frame * 4;

		Sprite[96 + a].HPos = sprx & 511;
		Sprite[96 + a].VPos = (spry + a * 8 + 256 - o) & 255;
    	Sprite[96 + a].Shape = DysonSizeShape[1];
   		Sprite[96 + a].Size =  DysonSizeShape[0]; //OAM_SIZE_64x64;
   		Sprite[96 +a].Pltt = 15;
         Sprite[96 + a].Priority = 1;

	} 
	if(h >= 20)
	{
		//AGBPrintf("h > 20 %d\n",dyson.height);
		//AGBPrintFlush();
	}
	for(a = h; a < 20; a++)
		Sprite[96 + a].VPos = 161;
	
	if(playergrabbed)
	{
		dyson.height = max(60,dyson.height - 2);
		game_y += smin(restart_ypos - dyson.height + 8 - game_y,8);
		player.ypos = dyson.height + game_y + 8;
		if(dyson.height == 60)
		{
			player.xpos += smin(restart_xpos - player.xpos,8);
			dyson.xpos = (player.xpos - game_x);
			if(player.xpos == restart_xpos)
			{
				for(a = 0; a < 20; a++)
					Sprite[96 + a].VPos = 161;
				remove();
				player.lives= max(0,player.lives - 1);
				player.health = 5;
				player_state = player_state_idle;
				dysonactive = 0;
			}
		}
		
	}
	else
	{
		dyson.ypos = min(0,dyson.ypos + 1);
		dyson.height = min(player.ypos - 8 - game_y,dyson.height + 2);
		if(dyson.height == (player.ypos - 8 - game_y))
		{	
		//	AGBPrintf("Player Grabbed!\n");
		//	AGBPrintFlush();
			playergrabbed = 1;
		}
	}
}

