void LoadLevel10(void) // Boss-2
{
    s32    	i,a;
    u16 x;
    u16 y;
	s16 view_x,view_y;
	u8 line;
	u16 map_x,map_y;
	u32 ptr,dest;
	u16 clock;
	
 // Level Specific stuff
 
 	MaxEnemies = 2; // so they don't overwrite the Boss's sprites
	MapActive = 0;
 
 	player.ActionFlags = 0;
      *(vu16 *)REG_IE    = V_BLANK_INTR_FLAG | H_BLANK_INTR_FLAG;           // Permit V blank interrupt
                    //  | CASSETTE_INTR_FLAG;          // Permit cassette interrupt
	
    *(vu16 *)REG_IME   = 1;                           // Set IME

	MosaicLevel(0);
MosaicIn();
	DisplayLoader(bigbossloaderChar,bigbossloaderPalette,bigbossloaderMap);
	col_map = &Boss2_col_map[0];
	col_tile_fine = &Boss2_col_tile_fine[0][0];

	SampleManager_Halt();

	TestDecompress((u8 *)layer_boss2_2,(s16 *)WorkMap,&PlayerMapWidth,&PlayerMapHeight);

 	KeyRead();
	clock = 0;
	while(!(controller_push & (pad_start | pad_A)) && clock < 120)
	{
  		KeyRead();                                  // Key control
        ArgoVBlank();                           // Complete V Blank interrupt
  		clock++;
	}
	GameScreen();
	MapActive = 1;
//	Screen2(1);
	Screen0(1);
	LoadStrats((s16 *)sprites_boss2);


   	DmaArrayCopy(3,tiles_ta_wahi1,BG_VRAM + 0x4000,32); // main map tiles (16k block 1)
	LoadMapPalette(palettes_ta_wahi1);
     	spawn(initpanel,4,4,0);

	LoadSprite((u32)LeWahiPlatformSprite,PLATFORM_SPRITE_OFFSET,(PLATFORM_SPRITE_SIZE * 2));
	LoadPalette(LeWahiPlatformPalette,8);

	// overlay bg map palette until new one is in
	
 	GameStateLoop = GameLoop; //FadeInLoop;
 	Screen2(0);
	refreshrahiboss();
}
