/*********************************************/
/*  player.h  test player strat routine      */
/*********************************************/
#ifndef _PLATFORM_H
#define _PLATFORM_H

#define MAX_PLATFORMS  32

void initplatform();
void initmovingplatform();
void initvmovingplatform();

void HandlePlatform();
void HandleMovingPlatform();
void HandleVMovingPlatform();
u8  NextPlatform(void);
void RemovePlatform(void);
void initbridge(void);

typedef struct {
	s16 xpos;
	s16 ypos;
	s16 xposL;	// for moving platforms. used as top/bottom y-co-ords for Vert moving platforms
	s16 xposR;
	s8 dx;		// 
	u8 frame;
	u8 state;
	u8 LinkedSwitch;
	u8 active;
	
} platparms;

typedef struct {
	s16 xpos;
	s16 ypos;
	s8 dy;
} plankparms;

platparms platform[MAX_PLATFORMS];

OamData PlatformTemplate;
OamData	PlatformTemplate2;
OamData PlankTemplate;

#endif
