// screen.h

#ifndef _SCREEN_H
#define _SCREEN_H

#include <AGB.h>


void MenuScreen(void);
void MenuScreenLayer1(void);
void GameScreen(void);
void FrontEndScreen(void);
void Screen0(u8 onoff);
void Screen1(u8 onoff);
void Screen2(u8 onoff);
void Screen3(u8 onoff);
void Screen1Base(u8 basebank);


void WipeToBlack(u8 fader);
void WipeToWhite(u8 fader);
void MosaicIn(void);
void MosaicOut(void);
void MosaicLevel(u8 a);
void Window0(u8 tlx, u8 tly,u8 brx,u8 bry,u8 flags);
void WindowOff0(void);
void Window1(u8 tlx, u8 tly,u8 brx,u8 bry,u8 flags);
void WindowOff1(void);
void WindowOut(u8 winflags);
void WindowObj(u8 flags);
void WindowOutObj(u8 outflags, u8 objflags);
void ScreenScale2(s32 scale);


#endif
