#include "Pool.h"

#define PALETTE (*(volatile unsigned short*)0x05000000)

Pool gPool;

void Pool::Init(void *memstart,int size)
{
	mHeapStart = memstart;
	mHeapSize = size;
	mNext = 0;
}

void *Pool::Allocate(int length)
{
	if (length > (mHeapSize-mNext))
	{
		while(1)
		{
			PALETTE = 0xff00;
		}
		return 0;
	}
	void *ret = ((char*)mHeapStart)+mNext;

	mNext += (length+3) & (~3);

	return ret;
}

void Pool::Free(void *memstart)
{
	// TODO
}
